$(function() {
    $('#add_service_dialog').dialog({
        modal: true,
        title: 'Add a service',
        width: '520px',
        autoOpen: false,
        draggable: false,
        resizable: false,
    });
})

function insert_resource(res_id, container_id, form, parent_id) {
    var num_res = Number(form.res_count.value);
    var is_vm = false;

    if (res_id == 'vm_resource') {
        is_vm = true;
        if ($('.reslevel').length != 0) {
            alert("VMs may have no children and may not be children of other resources.");
            return;
        }
        var sel_elem = $('.resource_selector', form);
        $(sel_elem).remove();
    }
    var is_global = res_id.match(/^global_res_/) != null;

    form.res_count.value = num_res + 1;

    var containing_div = $('<div class="reslevel"></div>');
    var cur_id_str = 'res_' + num_res;
    $(containing_div).attr('id', cur_id_str);

    var child_div = $('<div class="reschild"></div>');
    $(child_div).attr('id', 'children_res_' + num_res);

    var cntrl_div;
    if (!is_vm) {
        cntrl_div = $('<div class="row rescntrl">Add a child</div>');
        var res_selector = $(document.getElementById('resource_selector')).clone();
        if (!res_selector) {
            return (-1);
        }
        $(res_selector).removeAttr('id');
        $(res_selector).removeAttr('onchange');
        $(res_selector).change(function(){
            insert_resource(this.options[this.selectedIndex].value, 'children_res_' + num_res, form, cur_id_str);
            this.selectedIndex = 0;
        });
        $(res_selector).appendTo($(cntrl_div));
        var remove_button = $('<input type="button" value="Remove this resource" onclick="$(\'#' + cur_id_str + '\').remove()"/>');
        $(remove_button).appendTo($(cntrl_div));
    } else {
        cntrl_div = $('<div class="row rescntrl"></div>');
    }

    var dest_jelem = $(document.getElementById(container_id));
    if (!dest_jelem) {
        return;
    }

    var form_jelem = $(document.getElementById(res_id)).clone();
    if (!form_jelem) {
        return;
    }
    $(form_jelem).removeAttr('id');

    if (is_global) {
        $('<input type="hidden" name="global" value="1"/>').appendTo($(form_jelem));
    }

    var cur_resid_elem = $('input[name="form_id"]', form_jelem);
    $(cur_resid_elem).val(cur_id_str);

    var parent_resid_elem = $('input[name="parent_id"]', form_jelem);
    $(parent_resid_elem).val(parent_id);

    var tree_level_elem = $('input[name="tree_level"]', form_jelem);
    $(tree_level_elem).val(0);

    $(form_jelem).appendTo($(containing_div));
    $(child_div).appendTo($(containing_div));
    $(cntrl_div).appendTo($(containing_div));
    $(containing_div).appendTo($(dest_jelem));
}

function submit_svc_form(form) {
    var resform_jelem = $(form).find('.rescfg');
    var xml_str = '<formlist>';

    for (var i = 0 ; i < $(resform_jelem).length ; i++) {
        var cur_res = $(resform_jelem).eq(i);
        var cur_res_input = $(':input', cur_res);
        var cur_id = $('input[name="form_id"]', cur_res);
        var parent_id = $('input[name="parent_id"]', cur_res);
        var cur_xml = '<form id="' + $(cur_id).val() + '" parent="' + $(parent_id).val() + '">';
        $(cur_res_input).each(function(idx) {
            cur_xml += input_to_xml(this);
        });
        cur_xml += '</form>';
        xml_str += cur_xml;
    }
    form.form_xml.value =  xml_str + '</formlist>';
    form.submit();
}
